import java.util.*;
import java.util.stream.Stream;

public class Sample {
  public static void main(String[] args) {
    //Pick a stock and price where the price is the
    //highest but less than $500
    
//    Timeit.code(() -> {
//      List<StockInfo> stocks = new ArrayList<>();
//      for(String symbol : Tickers.symbols) {
//        stocks.add(StockUtil.getPrice(symbol));
//      }
//      
//      List<StockInfo> stocksLT500 = new ArrayList<>();
//      for(StockInfo stock : stocks) {
//        if(StockUtil.isPriceLessThan(500).test(stock))
//          stocksLT500.add(stock);
//      }
//      
//      StockInfo highPriced = new StockInfo("", 0.0);
//      for(StockInfo stock : stocksLT500) {
//        highPriced = StockUtil.pickHigh(highPriced, stock);
//      }
//      
//      System.out.println(highPriced);
//    });

    findHighPriced(Tickers.symbols.stream());
  }
  
  public static void findHighPriced(Stream<String> symbols) {
    StockInfo highPriced = new StockInfo("", 0.0);
    Timeit.code(() -> 
      System.out.println(
        symbols.map(StockUtil::getPrice)
               .filter(StockUtil.isPriceLessThan(500))
               .reduce(highPriced, StockUtil::pickHigh)
      ));
  }
}
